t / test-lib-functions.shon commit Merge branch 'jk/maint-commit-check-committer-early' into maint-1.7.11 (9e0833c)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# The semantics of the editor variables are that of invoking
  19# sh -c "$EDITOR \"$@\"" files ...
  20#
  21# If our trash directory contains shell metacharacters, they will be
  22# interpreted if we just set $EDITOR directly, so do a little dance with
  23# environment variables to work around this.
  24#
  25# In particular, quoting isn't enough, as the path may contain the same quote
  26# that we're using.
  27test_set_editor () {
  28        FAKE_EDITOR="$1"
  29        export FAKE_EDITOR
  30        EDITOR='"$FAKE_EDITOR"'
  31        export EDITOR
  32}
  33
  34test_decode_color () {
  35        awk '
  36                function name(n) {
  37                        if (n == 0) return "RESET";
  38                        if (n == 1) return "BOLD";
  39                        if (n == 30) return "BLACK";
  40                        if (n == 31) return "RED";
  41                        if (n == 32) return "GREEN";
  42                        if (n == 33) return "YELLOW";
  43                        if (n == 34) return "BLUE";
  44                        if (n == 35) return "MAGENTA";
  45                        if (n == 36) return "CYAN";
  46                        if (n == 37) return "WHITE";
  47                        if (n == 40) return "BLACK";
  48                        if (n == 41) return "BRED";
  49                        if (n == 42) return "BGREEN";
  50                        if (n == 43) return "BYELLOW";
  51                        if (n == 44) return "BBLUE";
  52                        if (n == 45) return "BMAGENTA";
  53                        if (n == 46) return "BCYAN";
  54                        if (n == 47) return "BWHITE";
  55                }
  56                {
  57                        while (match($0, /\033\[[0-9;]*m/) != 0) {
  58                                printf "%s<", substr($0, 1, RSTART-1);
  59                                codes = substr($0, RSTART+2, RLENGTH-3);
  60                                if (length(codes) == 0)
  61                                        printf "%s", name(0)
  62                                else {
  63                                        n = split(codes, ary, ";");
  64                                        sep = "";
  65                                        for (i = 1; i <= n; i++) {
  66                                                printf "%s%s", sep, name(ary[i]);
  67                                                sep = ";"
  68                                        }
  69                                }
  70                                printf ">";
  71                                $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
  72                        }
  73                        print
  74                }
  75        '
  76}
  77
  78nul_to_q () {
  79        "$PERL_PATH" -pe 'y/\000/Q/'
  80}
  81
  82q_to_nul () {
  83        "$PERL_PATH" -pe 'y/Q/\000/'
  84}
  85
  86q_to_cr () {
  87        tr Q '\015'
  88}
  89
  90q_to_tab () {
  91        tr Q '\011'
  92}
  93
  94append_cr () {
  95        sed -e 's/$/Q/' | tr Q '\015'
  96}
  97
  98remove_cr () {
  99        tr '\015' Q | sed -e 's/Q$//'
 100}
 101
 102# In some bourne shell implementations, the "unset" builtin returns
 103# nonzero status when a variable to be unset was not set in the first
 104# place.
 105#
 106# Use sane_unset when that should not be considered an error.
 107
 108sane_unset () {
 109        unset "$@"
 110        return 0
 111}
 112
 113test_tick () {
 114        if test -z "${test_tick+set}"
 115        then
 116                test_tick=1112911993
 117        else
 118                test_tick=$(($test_tick + 60))
 119        fi
 120        GIT_COMMITTER_DATE="$test_tick -0700"
 121        GIT_AUTHOR_DATE="$test_tick -0700"
 122        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 123}
 124
 125# Stop execution and start a shell. This is useful for debugging tests and
 126# only makes sense together with "-v".
 127#
 128# Be sure to remove all invocations of this command before submitting.
 129
 130test_pause () {
 131        if test "$verbose" = t; then
 132                "$SHELL_PATH" <&6 >&3 2>&4
 133        else
 134                error >&5 "test_pause requires --verbose"
 135        fi
 136}
 137
 138# Call test_commit with the arguments "<message> [<file> [<contents>]]"
 139#
 140# This will commit a file with the given contents and the given commit
 141# message.  It will also add a tag with <message> as name.
 142#
 143# Both <file> and <contents> default to <message>.
 144
 145test_commit () {
 146        notick= &&
 147        if test "z$1" = "z--notick"
 148        then
 149                notick=yes
 150                shift
 151        fi &&
 152        file=${2:-"$1.t"} &&
 153        echo "${3-$1}" > "$file" &&
 154        git add "$file" &&
 155        if test -z "$notick"
 156        then
 157                test_tick
 158        fi &&
 159        git commit -m "$1" &&
 160        git tag "$1"
 161}
 162
 163# Call test_merge with the arguments "<message> <commit>", where <commit>
 164# can be a tag pointing to the commit-to-merge.
 165
 166test_merge () {
 167        test_tick &&
 168        git merge -m "$1" "$2" &&
 169        git tag "$1"
 170}
 171
 172# This function helps systems where core.filemode=false is set.
 173# Use it instead of plain 'chmod +x' to set or unset the executable bit
 174# of a file in the working directory and add it to the index.
 175
 176test_chmod () {
 177        chmod "$@" &&
 178        git update-index --add "--chmod=$@"
 179}
 180
 181# Unset a configuration variable, but don't fail if it doesn't exist.
 182test_unconfig () {
 183        git config --unset-all "$@"
 184        config_status=$?
 185        case "$config_status" in
 186        5) # ok, nothing to unset
 187                config_status=0
 188                ;;
 189        esac
 190        return $config_status
 191}
 192
 193# Set git config, automatically unsetting it after the test is over.
 194test_config () {
 195        test_when_finished "test_unconfig '$1'" &&
 196        git config "$@"
 197}
 198
 199test_config_global () {
 200        test_when_finished "test_unconfig --global '$1'" &&
 201        git config --global "$@"
 202}
 203
 204write_script () {
 205        {
 206                echo "#!${2-"$SHELL_PATH"}" &&
 207                cat
 208        } >"$1" &&
 209        chmod +x "$1"
 210}
 211
 212# Use test_set_prereq to tell that a particular prerequisite is available.
 213# The prerequisite can later be checked for in two ways:
 214#
 215# - Explicitly using test_have_prereq.
 216#
 217# - Implicitly by specifying the prerequisite tag in the calls to
 218#   test_expect_{success,failure,code}.
 219#
 220# The single parameter is the prerequisite tag (a simple word, in all
 221# capital letters by convention).
 222
 223test_set_prereq () {
 224        satisfied="$satisfied$1 "
 225}
 226satisfied=" "
 227
 228test_have_prereq () {
 229        # prerequisites can be concatenated with ','
 230        save_IFS=$IFS
 231        IFS=,
 232        set -- $*
 233        IFS=$save_IFS
 234
 235        total_prereq=0
 236        ok_prereq=0
 237        missing_prereq=
 238
 239        for prerequisite
 240        do
 241                total_prereq=$(($total_prereq + 1))
 242                case $satisfied in
 243                *" $prerequisite "*)
 244                        ok_prereq=$(($ok_prereq + 1))
 245                        ;;
 246                *)
 247                        # Keep a list of missing prerequisites
 248                        if test -z "$missing_prereq"
 249                        then
 250                                missing_prereq=$prerequisite
 251                        else
 252                                missing_prereq="$prerequisite,$missing_prereq"
 253                        fi
 254                esac
 255        done
 256
 257        test $total_prereq = $ok_prereq
 258}
 259
 260test_declared_prereq () {
 261        case ",$test_prereq," in
 262        *,$1,*)
 263                return 0
 264                ;;
 265        esac
 266        return 1
 267}
 268
 269test_expect_failure () {
 270        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 271        test "$#" = 2 ||
 272        error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
 273        export test_prereq
 274        if ! test_skip "$@"
 275        then
 276                say >&3 "checking known breakage: $2"
 277                if test_run_ "$2" expecting_failure
 278                then
 279                        test_known_broken_ok_ "$1"
 280                else
 281                        test_known_broken_failure_ "$1"
 282                fi
 283        fi
 284        echo >&3 ""
 285}
 286
 287test_expect_success () {
 288        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 289        test "$#" = 2 ||
 290        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
 291        export test_prereq
 292        if ! test_skip "$@"
 293        then
 294                say >&3 "expecting success: $2"
 295                if test_run_ "$2"
 296                then
 297                        test_ok_ "$1"
 298                else
 299                        test_failure_ "$@"
 300                fi
 301        fi
 302        echo >&3 ""
 303}
 304
 305# test_external runs external test scripts that provide continuous
 306# test output about their progress, and succeeds/fails on
 307# zero/non-zero exit code.  It outputs the test output on stdout even
 308# in non-verbose mode, and announces the external script with "# run
 309# <n>: ..." before running it.  When providing relative paths, keep in
 310# mind that all scripts run in "trash directory".
 311# Usage: test_external description command arguments...
 312# Example: test_external 'Perl API' perl ../path/to/test.pl
 313test_external () {
 314        test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
 315        test "$#" = 3 ||
 316        error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
 317        descr="$1"
 318        shift
 319        export test_prereq
 320        if ! test_skip "$descr" "$@"
 321        then
 322                # Announce the script to reduce confusion about the
 323                # test output that follows.
 324                say_color "" "# run $test_count: $descr ($*)"
 325                # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
 326                # to be able to use them in script
 327                export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
 328                # Run command; redirect its stderr to &4 as in
 329                # test_run_, but keep its stdout on our stdout even in
 330                # non-verbose mode.
 331                "$@" 2>&4
 332                if [ "$?" = 0 ]
 333                then
 334                        if test $test_external_has_tap -eq 0; then
 335                                test_ok_ "$descr"
 336                        else
 337                                say_color "" "# test_external test $descr was ok"
 338                                test_success=$(($test_success + 1))
 339                        fi
 340                else
 341                        if test $test_external_has_tap -eq 0; then
 342                                test_failure_ "$descr" "$@"
 343                        else
 344                                say_color error "# test_external test $descr failed: $@"
 345                                test_failure=$(($test_failure + 1))
 346                        fi
 347                fi
 348        fi
 349}
 350
 351# Like test_external, but in addition tests that the command generated
 352# no output on stderr.
 353test_external_without_stderr () {
 354        # The temporary file has no (and must have no) security
 355        # implications.
 356        tmp=${TMPDIR:-/tmp}
 357        stderr="$tmp/git-external-stderr.$$.tmp"
 358        test_external "$@" 4> "$stderr"
 359        [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
 360        descr="no stderr: $1"
 361        shift
 362        say >&3 "# expecting no stderr from previous command"
 363        if [ ! -s "$stderr" ]; then
 364                rm "$stderr"
 365
 366                if test $test_external_has_tap -eq 0; then
 367                        test_ok_ "$descr"
 368                else
 369                        say_color "" "# test_external_without_stderr test $descr was ok"
 370                        test_success=$(($test_success + 1))
 371                fi
 372        else
 373                if [ "$verbose" = t ]; then
 374                        output=`echo; echo "# Stderr is:"; cat "$stderr"`
 375                else
 376                        output=
 377                fi
 378                # rm first in case test_failure exits.
 379                rm "$stderr"
 380                if test $test_external_has_tap -eq 0; then
 381                        test_failure_ "$descr" "$@" "$output"
 382                else
 383                        say_color error "# test_external_without_stderr test $descr failed: $@: $output"
 384                        test_failure=$(($test_failure + 1))
 385                fi
 386        fi
 387}
 388
 389# debugging-friendly alternatives to "test [-f|-d|-e]"
 390# The commands test the existence or non-existence of $1. $2 can be
 391# given to provide a more precise diagnosis.
 392test_path_is_file () {
 393        if ! [ -f "$1" ]
 394        then
 395                echo "File $1 doesn't exist. $*"
 396                false
 397        fi
 398}
 399
 400test_path_is_dir () {
 401        if ! [ -d "$1" ]
 402        then
 403                echo "Directory $1 doesn't exist. $*"
 404                false
 405        fi
 406}
 407
 408test_path_is_missing () {
 409        if [ -e "$1" ]
 410        then
 411                echo "Path exists:"
 412                ls -ld "$1"
 413                if [ $# -ge 1 ]; then
 414                        echo "$*"
 415                fi
 416                false
 417        fi
 418}
 419
 420# test_line_count checks that a file has the number of lines it
 421# ought to. For example:
 422#
 423#       test_expect_success 'produce exactly one line of output' '
 424#               do something >output &&
 425#               test_line_count = 1 output
 426#       '
 427#
 428# is like "test $(wc -l <output) = 1" except that it passes the
 429# output through when the number of lines is wrong.
 430
 431test_line_count () {
 432        if test $# != 3
 433        then
 434                error "bug in the test script: not 3 parameters to test_line_count"
 435        elif ! test $(wc -l <"$3") "$1" "$2"
 436        then
 437                echo "test_line_count: line count for $3 !$1 $2"
 438                cat "$3"
 439                return 1
 440        fi
 441}
 442
 443# This is not among top-level (test_expect_success | test_expect_failure)
 444# but is a prefix that can be used in the test script, like:
 445#
 446#       test_expect_success 'complain and die' '
 447#           do something &&
 448#           do something else &&
 449#           test_must_fail git checkout ../outerspace
 450#       '
 451#
 452# Writing this as "! git checkout ../outerspace" is wrong, because
 453# the failure could be due to a segv.  We want a controlled failure.
 454
 455test_must_fail () {
 456        "$@"
 457        exit_code=$?
 458        if test $exit_code = 0; then
 459                echo >&2 "test_must_fail: command succeeded: $*"
 460                return 1
 461        elif test $exit_code -gt 129 -a $exit_code -le 192; then
 462                echo >&2 "test_must_fail: died by signal: $*"
 463                return 1
 464        elif test $exit_code = 127; then
 465                echo >&2 "test_must_fail: command not found: $*"
 466                return 1
 467        fi
 468        return 0
 469}
 470
 471# Similar to test_must_fail, but tolerates success, too.  This is
 472# meant to be used in contexts like:
 473#
 474#       test_expect_success 'some command works without configuration' '
 475#               test_might_fail git config --unset all.configuration &&
 476#               do something
 477#       '
 478#
 479# Writing "git config --unset all.configuration || :" would be wrong,
 480# because we want to notice if it fails due to segv.
 481
 482test_might_fail () {
 483        "$@"
 484        exit_code=$?
 485        if test $exit_code -gt 129 -a $exit_code -le 192; then
 486                echo >&2 "test_might_fail: died by signal: $*"
 487                return 1
 488        elif test $exit_code = 127; then
 489                echo >&2 "test_might_fail: command not found: $*"
 490                return 1
 491        fi
 492        return 0
 493}
 494
 495# Similar to test_must_fail and test_might_fail, but check that a
 496# given command exited with a given exit code. Meant to be used as:
 497#
 498#       test_expect_success 'Merge with d/f conflicts' '
 499#               test_expect_code 1 git merge "merge msg" B master
 500#       '
 501
 502test_expect_code () {
 503        want_code=$1
 504        shift
 505        "$@"
 506        exit_code=$?
 507        if test $exit_code = $want_code
 508        then
 509                return 0
 510        fi
 511
 512        echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
 513        return 1
 514}
 515
 516# test_cmp is a helper function to compare actual and expected output.
 517# You can use it like:
 518#
 519#       test_expect_success 'foo works' '
 520#               echo expected >expected &&
 521#               foo >actual &&
 522#               test_cmp expected actual
 523#       '
 524#
 525# This could be written as either "cmp" or "diff -u", but:
 526# - cmp's output is not nearly as easy to read as diff -u
 527# - not all diff versions understand "-u"
 528
 529test_cmp() {
 530        $GIT_TEST_CMP "$@"
 531}
 532
 533# This function can be used to schedule some commands to be run
 534# unconditionally at the end of the test to restore sanity:
 535#
 536#       test_expect_success 'test core.capslock' '
 537#               git config core.capslock true &&
 538#               test_when_finished "git config --unset core.capslock" &&
 539#               hello world
 540#       '
 541#
 542# That would be roughly equivalent to
 543#
 544#       test_expect_success 'test core.capslock' '
 545#               git config core.capslock true &&
 546#               hello world
 547#               git config --unset core.capslock
 548#       '
 549#
 550# except that the greeting and config --unset must both succeed for
 551# the test to pass.
 552#
 553# Note that under --immediate mode, no clean-up is done to help diagnose
 554# what went wrong.
 555
 556test_when_finished () {
 557        test_cleanup="{ $*
 558                } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
 559}
 560
 561# Most tests can use the created repository, but some may need to create more.
 562# Usage: test_create_repo <directory>
 563test_create_repo () {
 564        test "$#" = 1 ||
 565        error "bug in the test script: not 1 parameter to test-create-repo"
 566        repo="$1"
 567        mkdir -p "$repo"
 568        (
 569                cd "$repo" || error "Cannot setup test environment"
 570                "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
 571                error "cannot run git init -- have you built things yet?"
 572                mv .git/hooks .git/hooks-disabled
 573        ) || exit
 574}